Unit ASC0C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASC0C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer);

implementation

procedure ASC0C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer);
var
I1,I2,I3 :Integer;
P,PII,RM,V1,V2 :Real;
F,E,E1 :Complex;
const
SYS003 :Real = 6.2831853071795864769252867665590;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin

{  ****************************************************************** C }
{                                                                     C }
{  ------------------------  HAHAEHE  ---------------------------- C }
{                                                                     C }
{       PEEHE CCTEM HEHX AEPAECKX YPABHEH  A X = B    C }
{       C PKYHTHO MATPE .                                     C }
{                                                                     C }
{       OPOHOE OCAHE :                                          C }
{       ( 1 ) E.E.TPTHKOB , O PEEH CCTEM C MATPAM TA     C }
{       TEEBX , B C. CEHH AHA HA OPTPAHE               C }
{       ( BCTEHE METO  HCTPYMEHTAHE CCTEM )  ,       C }
{       -BO MY , 1978 .                                           C }
{                                                                     C }
{                                                                     C }
{  ---------------------------  METO  ------------------------------ C }
{                                                                     C }
{       B OCHOBE AOPMA ET OOHOE PEOPAOBAHE MATP  A   C }
{       PAMEPA  M*M  K AOHAHO MATPE G . TO PEOPAOBAHE   C }
{       OCYECTBETC C OMO YHTAPHO MATP Q ,EMEHT KOTOPO C }
{       C HEKCAM  I , J  PABEH  E**((I-1)*(J-1))/M  , E   E -    C }
{       EPBOOPAH KOPEH  EH CTEEH  M . I- EMEHT      C }
{       AOHA MATP  G  ECT CYMMA O J OT 1 O M  BEH      C }
{       Q(I,J) * A(J,1) .TAKM OPAOM PEEHE CXOHO CCTEM       C }
{       CBOTC K PEEH CCTEM C AOHAHO MATPE  G .       C }
{                                                                     C }
{                                                                     C }
{  ------------------  K  POPAMMPOBAH  ---------------------- C }
{                                                                     C }
{       OPTPAH                                                       C }
{                                                                     C }
{                                                                     C }
{  -----------------  OPAHA - PAPAOTK  -------------------- C }
{                                                                     C }
{       HAYHO - CCEOBATECK BCTEH EHTP  M  Y ,      C }
{       AOPATOP  CEHHOO  AHAA                              C }
{                                                                     C }
{       APEC :                                                       C }
{       MOCKBA ,117234 , HB MY , AOPATOP CEHHOO AHAA    C }
{                                                                     C }
{  -----------------------  COOBAHE  -------------------------- C }
{                                                                     C }
{       CALL ASC0C(A,X,R,M)                                           C }
{                                                                     C }
{  -------------------------  APAMETP  ---------------------------- C }
{                                                                     C }
{       A - KOMEKCH OHOMEPH MACCB H  M , B KOTOPOM        C }
{           MATPA CCTEM AAETC CBOE EPBO CTPOKO .           C }
{                                                                     C }
{       X - KOMEKCH OHOMEPH MACCB H  M , B KOTOPOM        C }
{           AAETC PABA ACT . HA BXOE OPOPAMM B  X       C }
{           OYAETC PEEHE .                                      C }
{                                                                     C }
{       R - KOMEKCH OHOMEPH PAO MACCB H  M  .         C }
{                                                                     C }
{       M - OPOK MATP .                                         C }
{                                                                     C }
{                                                                     C }
{  -----------------  BBAEME  OPOPAMM  --------------------- C }
{  --                                                                 C }
{       HET                                                           C }
{                                                                     C }
{  ****************************************************************** C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{  -------------------------  KOHCTAHT  ---------------------------- C }

{       SYS003=6.2831853717958647692528 ( 2 *  ) }


PII := SYS003/M;
RM := 1.0/M;

P := 0.0;
for I1:=1 to M do
 begin
  V1 := Cos(P);
  V1 := Cos(P);
  V2 := Sin(P);
  E := Cmplx(V1,V2);
  E1 := Cmplx(1.0,0.0);
  F := Cmplx(0.0,0.0);
  for I2:=1 to M do
   begin
    F := AddC(F,MulC(E1,A[I2-1]));
    E1 := MulC(E1,E);
_1:
   end;
  R[I1-1] := F;
_2:
  P := PII*I1;
 end;
for I3:=1 to M do
 begin
_3:
  A[I3-1] := R[I3-1];
 end;

P := 0.0;
for I1:=1 to M do
 begin
  V1 := Cos(P);
  V2 := -Sin(P);
  E := Cmplx(V1,V2);
  E1 := Cmplx(1.0,0.0);
  F := Cmplx(0.0,0.0);
  for I2:=1 to M do
   begin
    F := AddC(F,MulC(E1,X[I2-1]));
    E1 := MulC(E1,E);
_4:
   end;
  R[I1-1] := F;
_5:
  P := PII*I1;
 end;

for I3:=1 to M do
 begin
_6:
  X[I3-1] := DivC(R[I3-1],A[I3-1]);
 end;

P := 0.0;
for I1:=1 to M do
 begin
  V1 := Cos(P);
  V2 := Sin(P);
  E := Cmplx(V1,V2);
  E1 := Cmplx(1.0,0.0);
  F := Cmplx(0.0,0.0);
  for I2:=1 to M do
   begin
    F := AddC(F,MulC(E1,X[I2-1]));
    E1 := MulC(E1,E);
_7:
   end;
  R[I1-1] := F;
_8:
  P := PII*I1;
 end;

for I3:=1 to M do
 begin
_9:
  X[I3-1] := MulC(R[I3-1],Cmplx(RM,0.0));
 end;

end;

end.
